/******************************************************************************
;  *       @ͺ                 : MC51F003A4
;  *       @             : 2023.02.01
;  *       @˾/            : SINOMCU.COM-AE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : ΢ Ȩ.
;  *----------------------ժҪ---------------------------------
;  *    MC51F003 Ӳ˳ʹʾ.
;  *LED2ת1S,printfضUART1.reame.txt.
******************************************************************************/

#include "User_Def.h"

#define REV_STR "2023-02-01"
uint8_t code HW_buff[]="\r\n\r\n***** MS51F003 MUL DIV *****\r\n*****rev:"REV_STR" "__TIME__; 

#define LED_BLINK_HALF_PRE        50                       /*uint 10ms*/

__O B4BIT SFR_interrupt_buff_H;
__O B4BIT SFR_interrupt_buff_L;

void main(void) {
  uint8_t  LED_count  =0;
  uint32_t mul_result =0;
  uint16_t cacl_varA  =MUL_DIV_VAR_A,div_result=0;
  uint8_t  cacl_varB  =MUL_DIV_VAR_B;

  EN_MUL_DIV_16(); /*ʹ16bitӲ˳*/
      
  DISABLE_GIE();   /*رж*/
  GPIO_Init();
  TIM0_Init(TIM_TICK_1MS);
  UART1_Init(BAUD_RATE);
  ENABLE_GIE();    /*ж*/

  printf(HW_buff);
  Start_10MS_SF_Timer();
#if(defined(EN_HW_MUL_DIV) && EN_HW_MUL_DIV )
  printf("\r\n--Inf:MCU MUL DIV.");
#else
  printf("\r\n--Inf:Lib MUL DIV.");
#endif  
  while (1) {
    if(Get_State_10MS_SF_Timer() == SF_TIMER_OV) {
      Start_10MS_SF_Timer();
      
      LED_count++;
      if( LED_count ==LED_BLINK_HALF_PRE) {
        mul_result=Cacl_16mul8(cacl_varA,cacl_varB);
        div_result = Cacl_16div8(cacl_varA,cacl_varB);
        printf("\r\n--Inf: %d * %d =%ld.",cacl_varA,(uint16_t)cacl_varB,mul_result);
        printf("\r\n--Inf: %d / %d =%d,Remadinder %d",cacl_varA,(uint16_t)cacl_varB,div_result,(uint16_t)g_div_remainder);        
        
        LED_count =0;
        LED2_TOGGLE();
      }
    }
  }
}

/**************************** end of file *********************************************/
